/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.system.action;

import java.sql.SQLException;
import java.util.List;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.payroll.base.PayrollAction;
import jp.mosp.payroll.base.PayrollConst;
import jp.mosp.payroll.dao.PmDetailPaDao;
import jp.mosp.payroll.dao.PmDetailPbDao;
import jp.mosp.payroll.dao.PmDetailPdDao;
import jp.mosp.payroll.dao.PmDetailPsDao;
import jp.mosp.payroll.dao.PmDetailPtDao;

import jp.mosp.payroll.bonus.dao.PmDetailBaDao;
import jp.mosp.payroll.bonus.dao.PmDetailBdDao;
import jp.mosp.payroll.bonus.dao.PmDetailBsDao;

import jp.mosp.payroll.system.vo.DetailListVo;

/**
 * 明細設定一覧画面における処理を行う。<br><br>
 * 以下のコマンドを扱う。
 * <ul><li>
 * {@link #CMD_SHOW}
 * </li><li>
 * {@link #CMD_SEARCH}
 * </li><li>
 * {@link #CMD_RE_SEARCH}
 * </li><li>
 * {@link #CMD_SORT}
 * </li><li>
 * {@link #CMD_PAGE}
 * </li></ul>
 */
public class DetailListAction extends PayrollAction {
	
	/**
	 * 画面表示コマンド。<br><br>
	 * 明細設定一覧画面を表示する。<br>
	 */
	public static final String CMD_SHOW = "P7010";
	
	/**
	 * 検索コマンド。<br><br>
	 * 指定された条件で明細設定の検索を行い、一覧表示する。<br>
	 */
	public static final String CMD_SEARCH = "P7011";
	
	/**
	 * 再検索コマンド。<br><br>
	 * 保存された条件で明細設定の検索を行い、一覧表示する。<br>
	 */
	public static final String CMD_RE_SEARCH = "P7012";
	
	/**
	 * ソートコマンド。<br><br>
	 * 指定された条件で明細設定の並べ替えを行い、一覧表示する。<br>
	 */
	public static final String CMD_SORT = "P7013";
	
	/**
	 * ページコマンド。<br><br>
	 * 指定された条件で明細設定のページ繰りを行い、一覧表示する。<br>
	 */
	public static final String CMD_PAGE = "P7014";
	
	/**
	 * Actionの初期化を行う。<br><br>
	 * 以下の処理を行う。
	 * <ul><li>
	 * {@link PayrollAction#PayrollAction()}
	 * </li></ul>
	 */
	public DetailListAction() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.common.common.BaseAction#getSpecificVo()
	 */
	@Override
	protected BaseVo getSpecificVo() {
		return new DetailListVo();
	}
	
	/**
	 * アクション。<br>
	 * 詳細は、クラス説明を参照。<br>
	 */
	public void action() throws Exception {
		// VO取得及び設定
		prepareVo();
		if (this.cmd.equals(CMD_SHOW)) {
			// 画面表示
			show();
		} else if (this.cmd.equals(CMD_SEARCH)) {
			// 検索処理
			search();
		} else if (this.cmd.equals(CMD_RE_SEARCH)) {
			// 再検索処理
			reSearch();
		} else if (this.cmd.equals(CMD_SORT)) {
			// ソート処理
			sort();
		} else if (this.cmd.equals(CMD_PAGE)) {
			// ページ処理
			page();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	/**
	 * 画面表示処理を行う。<br><br>
	 * @throws Exception 
	 */
	private void show() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// VOフィールド設定
		vo.setPltType  (String.valueOf(PayrollConst.DETAIL_TYPE_PT));
		vo.setTxtAbbr  ("");
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
	}
	
	/**
	 * 検索処理を行う。
	 * @throws Exception 
	 */
	private void search() throws Exception {
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// パラメータ取得
		vo.setParams(request);
		// リスト取得
		getList();
	}
	
	/**
	 * 	再検索処理を行う。
	 * @throws Exception 
	 */
	private void reSearch() throws Exception {
		// リスト取得
		getList();
	}
	
	/**
	 * ソート処理を行う。
	 * @throws Exception 
	 */
	private void sort() throws Exception {
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// ソート情報設定
		vo.setSortKey(key1);
		vo.setSelectIndex(1);
		// リスト取得
		getList();
	}
	
	/**
	 * ページ処理を行う。
	 * @throws Exception 
	 */
	private void page() throws Exception {
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// ページ情報設定
		vo.setSelectIndex(Integer.parseInt(key1));
		// リスト取得
		getList();
	}
	
	/**
	 * リストを取得する。
	 * @throws Exception 
	 */
	private void getList() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// 明細区分毎リスト取得
		if (vo.getPltType().equals(PayrollConst.DETAIL_TYPE_PT)) {
			// 給与勤怠
			getListPt();
		} else if (vo.getPltType().equals(PayrollConst.DETAIL_TYPE_PA)) {
			// 給与支給
			getListPa();
		} else if (vo.getPltType().equals(PayrollConst.DETAIL_TYPE_PD)) {
			// 給与控除
			getListPd();
		} else if (vo.getPltType().equals(PayrollConst.DETAIL_TYPE_PB)) {
			// 給与内訳
			getListPb();
		} else if (vo.getPltType().equals(PayrollConst.DETAIL_TYPE_PS)) {
			// 給与合計
			getListPs();
		} else if (vo.getPltType().equals(PayrollConst.DETAIL_TYPE_BA)) {
			// 賞与支給
			getListBa();
		} else if (vo.getPltType().equals(PayrollConst.DETAIL_TYPE_BD)) {
			// 賞与控除
			getListBd();
		} else if (vo.getPltType().equals(PayrollConst.DETAIL_TYPE_BS)) {
			// 賞与合計
			getListBs();
		}
		// 対象が無かった場合のメッセージ設定
		if (vo.getCount() == 0) {
			vo.addErrMessage(MospUtility.getMessage(msg, MospConst.MSG_NO_DATA, ""));
		}
	}
	
	/**
	 * 給与勤怠明細設定リストを取得する。
	 * @throws SQLException 
	 * @throws IllegalAccessException 
	 */
	private void getListPt() throws SQLException, IllegalAccessException {
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// DAO準備
		PmDetailPtDao dao = new PmDetailPtDao(cfg, cmd, aspUser, user, conn);
		// 件数取得
		vo.setCountAllData(dao.count(vo.getTxtAbbr(), vo.getPltDelete()));
		// 検索
		List<?> list = dao.find(
				vo.getTxtAbbr    (),
				vo.getPltDelete  (),
				getSortKey       (),
				vo.getIsAscending(),
				vo.getDataPerPage(),
				vo.getOffset     ()
		);
		// VOに設定
		vo.setFields(list);
	}
	
	/**
	 * 給与支給明細設定リストを取得する。
	 * @throws SQLException 
	 * @throws IllegalAccessException 
	 */
	private void getListPa() throws SQLException, IllegalAccessException {
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// DAO準備
		PmDetailPaDao dao = new PmDetailPaDao(cfg, cmd, aspUser, user, conn);
		// 件数取得
		vo.setCountAllData(dao.count(vo.getTxtAbbr(), vo.getPltDelete()));
		// 検索
		List<?> list = dao.find(
				vo.getTxtAbbr    (),
				vo.getPltDelete  (),
				getSortKey       (),
				vo.getIsAscending(),
				vo.getDataPerPage(),
				vo.getOffset     ()
		);
		// VOに設定
		vo.setFields(list);
	}
	
	/**
	 * 給与控除明細設定リストを取得する。
	 * @throws SQLException 
	 * @throws IllegalAccessException 
	 */
	private void getListPd() throws SQLException, IllegalAccessException {
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// DAO準備
		PmDetailPdDao dao = new PmDetailPdDao(cfg, cmd, aspUser, user, conn);
		// 件数取得
		vo.setCountAllData(dao.count(vo.getTxtAbbr(), vo.getPltDelete()));
		// 検索
		List<?> list = dao.find(
				vo.getTxtAbbr    (),
				vo.getPltDelete  (),
				getSortKey       (),
				vo.getIsAscending(),
				vo.getDataPerPage(),
				vo.getOffset     ()
		);
		// VOに設定
		vo.setFields(list);
	}
	
	/**
	 * 給与内訳明細設定リストを取得する。
	 * @throws SQLException 
	 * @throws IllegalAccessException 
	 */
	private void getListPb() throws SQLException, IllegalAccessException {
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// DAO準備
		PmDetailPbDao dao = new PmDetailPbDao(cfg, cmd, aspUser, user, conn);
		// 件数取得
		vo.setCountAllData(dao.count(vo.getTxtAbbr(), vo.getPltDelete()));
		// 検索
		List<?> list = dao.find(
				vo.getTxtAbbr    (),
				vo.getPltDelete  (),
				getSortKey       (),
				vo.getIsAscending(),
				vo.getDataPerPage(),
				vo.getOffset     ()
		);
		// VOに設定
		vo.setFields(list);
	}
	
	/**
	 * 給与合計明細設定リストを取得する。
	 * @throws SQLException 
	 * @throws IllegalAccessException 
	 */
	private void getListPs() throws SQLException, IllegalAccessException {
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// DAO準備
		PmDetailPsDao dao = new PmDetailPsDao(cfg, cmd, aspUser, user, conn);
		// 件数取得
		vo.setCountAllData(dao.count(vo.getTxtAbbr(), vo.getPltDelete()));
		// 検索
		List<?> list = dao.find(
				vo.getTxtAbbr    (),
				vo.getPltDelete  (),
				getSortKey       (),
				vo.getIsAscending(),
				vo.getDataPerPage(),
				vo.getOffset     ()
		);
		// VOに設定
		vo.setFields(list);
	}

	/**
	 * 賞与支給明細設定リストを取得する。
	 * @throws SQLException 
	 * @throws IllegalAccessException 
	 */
	private void getListBa() throws SQLException, IllegalAccessException {
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// DAO準備
		PmDetailBaDao dao = new PmDetailBaDao(cfg, cmd, aspUser, user, conn);
		// 件数取得
		vo.setCountAllData(dao.count(vo.getTxtAbbr(), vo.getPltDelete()));
		// 検索
		List<?> list = dao.find(
				vo.getTxtAbbr    (),
				vo.getPltDelete  (),
				getSortKey       (),
				vo.getIsAscending(),
				vo.getDataPerPage(),
				vo.getOffset     ()
		);
		// VOに設定
		vo.setFields(list);
	}
	
	/**
	 * 賞与控除明細設定リストを取得する。
	 * @throws SQLException 
	 * @throws IllegalAccessException 
	 */
	private void getListBd() throws SQLException, IllegalAccessException {
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// DAO準備
		PmDetailBdDao dao = new PmDetailBdDao(cfg, cmd, aspUser, user, conn);
		// 件数取得
		vo.setCountAllData(dao.count(vo.getTxtAbbr(), vo.getPltDelete()));
		// 検索
		List<?> list = dao.find(
				vo.getTxtAbbr    (),
				vo.getPltDelete  (),
				getSortKey       (),
				vo.getIsAscending(),
				vo.getDataPerPage(),
				vo.getOffset     ()
		);
		// VOに設定
		vo.setFields(list);
	}
	
	/**
	 * 賞与合計明細設定リストを取得する。
	 * @throws SQLException 
	 * @throws IllegalAccessException 
	 */
	private void getListBs() throws SQLException, IllegalAccessException {
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// DAO準備
		PmDetailBsDao dao = new PmDetailBsDao(cfg, cmd, aspUser, user, conn);
		// 件数取得
		vo.setCountAllData(dao.count(vo.getTxtAbbr(), vo.getPltDelete()));
		// 検索
		List<?> list = dao.find(
				vo.getTxtAbbr    (),
				vo.getPltDelete  (),
				getSortKey       (),
				vo.getIsAscending(),
				vo.getDataPerPage(),
				vo.getOffset     ()
		);
		// VOに設定
		vo.setFields(list);
	}

	/**
	 * ソートキーを取得する。<br>
	 * @return ソートキー
	 */
	private String getSortKey() {
		// VO取得
		DetailListVo vo = (DetailListVo)getVo();
		// 選択キー取得
		String selectKey = vo.getSelectKey();
		// ソートキー取得
		String sortKey = PmDetailPaDao.COL_DETAIL_CODE;
		if (selectKey == null) {
			// 処理無し
		} else if (selectKey.equals("2")) {
			sortKey = PmDetailPaDao.COL_DETAIL_NAME;
		} else if (selectKey.equals("3")) {
			sortKey = PmDetailPaDao.COL_DETAIL_ABBR;
		} else if (selectKey.equals("4")) {
			sortKey = PmDetailPaDao.COL_DELETE_FLAG;
		}
		return sortKey;
	}

}
